Gyoto::Metric::Hayward Class Reference

Metric of a regular rotating black hole or naked worm-hole. More...

`#include <GyotoHayward.h>`

Inheritance diagram for Gyoto::Metric::Hayward:

## Public Types

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > | Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)
| A subcontractor builds an object upon order from the Factory.

## Public Member Functions

virtual Property const * | getProperties () const
| Get list of properties.
| Hayward ()
| Default constructor.
virtual Hayward * | clone () const
| Virtual copy constructor.
void | spin (const double spin)
| Set spin.
double | spin () const
| Returns spin.
void | charge (const double charge)
| Set charge.
double | charge () const
| Returns charge.
virtual double | getSpecificAngularMomentum (double rr) const
virtual double | getPotential (double const pos[4], double l_cst) const
virtual void | circularVelocity (double const coor[4], double vel[4], double dir) const
| Yield circular velocity at a given position.
void | gmunu (double ARGOUT_ARRAY2[4][4], const double IN_ARRAY1[4]) const
| Metric coefficients.
double | gmunu (double const x[4], int mu, int nu) const
| Metric coefficients.
void | gmunu_up (double ARGOUT_ARRAY2[4][4], const double IN_ARRAY1[4]) const
| Metric contravariant coefficients.
double | gmunu_up (double const x[4], int mu, int nu) const
| Metric contravariant coefficients.
int | christoffel (double dst[4][4][4], const double pos[4]) const
| Chistoffel symbol.
double | ScalarProd (const double pos[4], const double u1[4], const double u2[4]) const
| Scalar product.
virtual double | christoffel (const double coord[4], const int alpha, const int mu, const int nu) const
| Chistoffel symbol.
int | coordKind () const
| Get coordinate kind.
int | getRefCount ()
virtual void | mass (const double)
| Set mass used in unitLength().
virtual void | mass (const double, const std::string &unit)
| Set mass used in unitLength().
double | mass () const
| Get mass used in unitLength().
double | mass (const std::string &unit) const
| Get mass used in unitLength().
double | unitLength () const
| M * G / c^2, M is in kg, unitLength in meters.
double | unitLength (const std::string &unit) const
| unitLength expressed in specified unit
virtual double | getRmb () const
virtual double | getRms () const
double | deltaMin () const
void | deltaMin (double h1)
double | deltaMax () const
virtual double | deltaMax (double const pos[8], double delta_max_external) const
void | deltaMax (double h1)
double | deltaMaxOverR () const
| Get delta_max_over_r_.
void | deltaMaxOverR (double t)
| Set delta_max_over_r_.
bool | keplerian () const
| Get keplerian_.
void | keplerian (bool)
| Set keplerian_.
virtual void | cartesianVelocity (double const coord[8], double vel[3])
| Compute xprime, yprime and zprime from 8-coordinates.
virtual double | SysPrimeToTdot (const double coord[4], const double v[3]) const
| Compute tdot as a function of dr/dt, dtheta/dt and dphi/dt. Everything is in geometrical units.
virtual void | zamoVelocity (double const pos[4], double vel[4]) const
| Yield ZAMO velocity at a given position.
virtual void | nullifyCoord (double coord[8]) const
| Set tdot (coord[4]) such that coord is light-like. Everything is in geometrical units.
virtual void | nullifyCoord (double coord[8], double &tdot2) const
| Set tdot (coord[4]) such that coord is light-like and return other possible tdot.
virtual void | normalizeFourVel (double coord[8]) const
| Normalize fourvelvel to -1.
virtual void | normalizeFourVel (double const pos[4], double fourvel[4]) const
| Normalize fourvelvel to -1.
double | norm (const double pos[4], const double u1[4]) const
| Scalar product.
void | multiplyFourVect (double vect[4], double a) const
| multiply vector by scalar
void | addFourVect (double u1[4], double const u2[4]) const
| add second vector to first one
void | projectFourVect (double const pos[4], double u1[4], double const u2[4]) const
| project u1 orthogonally to u2 at pos
void | dualOneForm (double const IN_ARRAY1_1[4], double const IN_ARRAY1_2[4], double ARGOUT_ARRAY1[4]) const
| Computes dual 1-form Compute the dual 1-form of 4-vector.
virtual void | observerTetrad (obskind_t obskind, double const pos[4], double fourvel[4], double screen1[4], double screen2[4], double screen3[4]) const
| Computes the orthonormal local tetrad of the observer.
virtual void | observerTetrad (double const pos[4], double fourvel[4], double screen1[4], double screen2[4], double screen3[4]) const
| Computes the orthonormal local tetrad of the observer.
void | GramSchmidt (double const pos[4], double u0[4], double u1[4], double u2[4], double u3[4]) const
| Apply Gram-Schmidt orthonormalization to a basis.
virtual void | jacobian (double ARGOUT_ARRAY3[4][4][4], const double IN_ARRAY1[4]) const
| Derivatives of the metric covariant coefficients.
virtual void | gmunu_up_and_jacobian (double ARGOUT_ARRAY2[4][4], double ARGOUT_ARRAY3[4][4][4], const double IN_ARRAY1[4]) const
| gmunu_up() and jacobian() in one go
virtual void | computeNBeta (const double coord[4], double &NN, double beta[3]) const
| Computes lapse scalar and shift vector at coord.
virtual int | myrk4 (Worldline *line, state_t const &coord, double h, state_t &res) const
| RK4 integrator.
virtual int | myrk4 (Worldline *line, const double coord[8], double h, double res[8]) const =delete
| Obsolete, update your code.
virtual int | myrk4_adaptive (Gyoto::Worldline *line, state_t const &coord, double lastnorm, double normref, state_t &coordnew, double h0, double &h1, double deltamax=GYOTO_DEFAULT_DELTA_MAX) const
| RK4 integrator with adaptive step.
virtual int | myrk4_adaptive (Gyoto::Worldline *line, const double coord[8], double lastnorm, double normref, double coordnew[8], double h0, double &h1, double deltamax=GYOTO_DEFAULT_DELTA_MAX) const =delete
| Obsolete, update your code.
virtual int | isStopCondition (double const coord[8]) const
| Check whether integration should stop.
virtual int | diff (state_t const &x, state_t &dxdt, double mass) const
| F function such as dx/dt=F(x,cst).
virtual int | diff (state_t const &x, state_t &dxdt) const =delete
| Obsolete, update your code.
virtual int | diff (const double y[8], double res[8]) const =delete
virtual int | diff31 (state_t const &x, state_t &dxdt, double mass) const
| F function such as dx/dt=F(x,cst) for 3+1 case.
virtual void | setParticleProperties (Gyoto::Worldline *line, double const coord[8]) const
| Set Metric-specific constants of motion. Used e.g. in KerrBL.
void | incRefCount ()
| Increment the reference counter. Warning: Don't mess with the counter.
int | decRefCount ()
| Decrement the reference counter and return current value. Warning: Don't mess with the counter.
virtual bool | isThreadSafe () const
| Whether this class is thread-safe.
virtual void | set (Property const &p, Value val)
| Set Value of a Property.
virtual void | set (Property const &p, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual void | set (std::string const &pname, Value val)
| Set Value of a Property.
virtual void | set (std::string const &pname, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual Value | get (Property const &p) const
| Get Value of a Property.
virtual Value | get (std::string const &pname) const
| Get Value of a Property.
virtual Value | get (Property const &p, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual Value | get (std::string const &pname, std::string const &unit) const
| Get Value of a Property, converted to unit.
Property const * | property (std::string const pname) const
| Find property by name.
virtual void | fillProperty (Gyoto::FactoryMessenger *fmp, Property const &p) const
| Output a single Property to XML.
virtual void | fillElement (Gyoto::FactoryMessenger *fmp) const
| Fill the XML element for this Object.
virtual void | setParameters (Gyoto::FactoryMessenger *fmp)
| Main loop for parsing Properties from XML description.
virtual int | setParameter (std::string name, std::string content, std::string unit)
| Set parameter by name.
virtual void | setParameter (Gyoto::Property const &p, std::string const &name, std::string const &content, std::string const &unit)
| Set parameter by Property (and name).
std::string | describeProperty (Gyoto::Property const &p) const
| Format desrciption for a property.
void | help () const
| Print (to stdout) some help on this class.
virtual std::string | kind () const
| Get kind_.
virtual void | hook (Listener *listener)
| Start listening.
virtual void | unhook (Listener *listener)
| Stop listening.

## Static Public Attributes

static GYOTO_OBJECT Property const | properties []

## Protected Member Functions

void | coordKind (int coordkind)
| Set coordkind_.
virtual void | kind (const std::string)
| Set kind_.
virtual void | tellListeners ()
| Call tell() on each hooked Listener.

## Protected Attributes

double | charge_
| Magnetic charge parameter.
double | spin_
| Angular momentum parameter.
double | a2_
| spin_*spin_
double | a3_
| a2_*spin_
double | a4_
| a2_*a2_
double | b2_
| charge_*charge_
double | delta_min_
| Minimum integration step for the adaptive integrator.
double | delta_max_
| Maximum integration step for the adaptive integrator.
double | delta_max_over_r_
| Numerical tuning parameter.
bool | keplerian_
| 1 if circularVelocity should return the Newtonian Keplerian velocity, in r^-3/2
std::string | kind_
| The "kind" that is output in the XML entity.
std::vector< std::string > | plugins_
| The plug-ins that needs to be loaded to access this instance's class.

## Private Attributes

double | mass_
| Mass yielding geometrical unit (in kg).
int | coordkind_
| Kind of coordinates (cartesian-like, spherical-like, unspecified).
int | __defaultfeatures
| Whether some virtual methods are implemented.
int | refCount
| Reference counter.
pthread_mutex_t | mutex_
| A mutex.
ListenerItem * | listeners_
| Linked list of Listener items.

## Friends

class | Gyoto::SmartPointer< Gyoto::Metric::Hayward >

## Detailed Description

Metric of a regular rotating black hole or naked worm-hole.

This is a regular rotating extension of Hayward's metric.

The metric reads: ds^2=-(1-2*M(r)*r/Sigma)*dt^2-(4*a*M(r)*sin^2(theta)/Sigma)*dt*dphi+(Sigma/Delta)*dr^2+(Sigma)*dtheta^2+sin^2(theta)*[r^2+a^2+2*a^2*r*M(r)*sin^2(theta)/Sigma]*dphi^2, where: Sigma=r^2+a^2*cos^2(theta) Delta=r^2-2*M(r)*r+a^2 M(r)=M*abs(r)^3/(abs(r)^3+2*m*b^2), m being the mass of the black hole seen at infinity and b a magnetic charge parameter.

See Lamy et al. (2018), Classical and Quantum Gravity, submitted, https://arxiv.org/abs/1802.01635

See Hayward (2006) for the original nonrotating metric, https://journals.aps.org/prl/abstract/10.1103/PhysRevLett.96.031103

See Bambi & Modesto (2013) for a rotating (but singular) extension. https://www.sciencedirect.com/science/article/pii/S0370269313002505?via%3Dihub

## Member Typedef Documentation

## Subcontractor_t

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > Gyoto::SmartPointee::Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)

inherited

A subcontractor builds an object upon order from the Factory.

Various classes need to provide a subcontractor to be able to instantiate themselves upon order from the Factory. A subcontractor is a function (often a static member function) which accepts a pointer to a FactoryMessenger as unique parameter, communicates with the Factory using this messenger to read an XML description of the object to build, and returns this objet. SmartPointee::Subcontractor_t* is just generic enough a typedef to cast to and from other subcontractor types: Astrobj::Subcontractor_t, Metric::Subcontractor_t, Spectrum::Subcontractor_t. A subcontractor needs to be registered using the relevant Register() function: Astrobj::Register(), Metric::Register(), Spectrum::Register().

## Member Function Documentation

## christoffel() [1/2]

virtual double Gyoto::Metric::Generic::christoffel | ( | const double | coord[4],
|  | const int | alpha,
|  | const int | mu,
|  | const int | nu ) const

virtual

Chistoffel symbol.

Value of Christoffel symbol Γαμν at point (x1, x2, x3).

Reimplemented from Gyoto::Metric::Generic.

## christoffel() [2/2]

int Gyoto::Metric::Hayward::christoffel | ( | double | dst[4][4][4],
|  | const double | coord[4] ) const

virtual

Chistoffel symbol.

Value of Christoffel symbol Γαμν at point (x1, x2, x3).

Returns
  1 on error, 0 otherwise

Reimplemented from Gyoto::Metric::Generic.

## circularVelocity()

virtual void Gyoto::Metric::Hayward::circularVelocity | ( | double const | pos[4],
|  | double | vel[4],
|  | double | dir ) const

virtual

Yield circular velocity at a given position.

Give the velocity of a massive particle in circular orbit at the given position projected onto the equatorial plane. Such a velocity may not exist everywhere (or anywhere) for a given metric. This method is intended to be used by Astrobj classes such as Torus or ThinDisk.

If keplerian_ is set to true, this method should return the Keplerian velcity instead (derived classes should ensure this, see KerrBL::circularVelocity() for instance).

The default implementation throws an error if keplerian_ is set to false.

Parameters

  pos | input: position,
  vel | output: velocity,
  dir | 1 for corotating, -1 for counterrotating.

Reimplemented from Gyoto::Metric::Generic.

## clone()

virtual Hayward * Gyoto::Metric::Hayward::clone | ( |  | ) | const

virtual

Virtual copy constructor.

Reimplemented from Gyoto::Metric::Generic.

## computeNBeta()

virtual void Gyoto::Metric::Generic::computeNBeta | ( | const double | coord[4],
|  | double & | NN,
|  | double | beta[3] ) const

virtual inherited

Computes lapse scalar and shift vector at coord.

Reimplemented in Gyoto::Metric::KerrBL, and Gyoto::Metric::NumericalMetricLorene.

## coordKind()

void Gyoto::Metric::Generic::coordKind | ( | int | coordkind | ) |

protected inherited

Set coordkind_.

coordkind(int coordkind) is protected because, for most Metrics, it should not be changed in runtime. Set coordinate kind

## deltaMax() [1/3]

double Gyoto::Metric::Generic::deltaMax | ( |  | ) | const

inherited

Get delta_max_

## deltaMax() [2/3]

virtual double Gyoto::Metric::Generic::deltaMax | ( | double const | pos[8],
|  | double | delta_max_external ) const

virtual inherited

Get delta max at a given position

Parameters

  pos | 4-position
  [optional] | delta_max_external external constraint on delta_max

Returns
  the smallest value between delta_max_, delta_max_external, and R*delta_max_over_r_ where R is pos[1] in spherical coordinates and max(x1, x2, x3) in Cartesian coordinates.

## deltaMax() [3/3]

void Gyoto::Metric::Generic::deltaMax | ( | double | h1 | ) |

inherited

Set delta_max_

## deltaMin() [1/2]

double Gyoto::Metric::Generic::deltaMin | ( |  | ) | const

inherited

Get delta_min_

## deltaMin() [2/2]

void Gyoto::Metric::Generic::deltaMin | ( | double | h1 | ) |

inherited

Set delta_min_

## describeProperty()

std::string Gyoto::Object::describeProperty | ( | Gyoto::Property const & | p | ) | const

inherited

Format desrciption for a property.

Returns a string containing the name(s) and type of the property, as well as whether it supports unit.

## diff() [1/3]

virtual int Gyoto::Metric::Generic::diff | ( | const double | y[8],
|  | double | res[8] ) const

virtual delete inherited

Reimplemented in Gyoto::Metric::KerrBL.

## diff() [2/3]

virtual int Gyoto::Metric::Generic::diff | ( | state_t const & | x,
|  | state_t & | dxdt ) const

virtual delete inherited

Obsolete, update your code.

Reimplemented in Gyoto::Metric::KerrBL.

## diff() [3/3]

virtual int Gyoto::Metric::Generic::diff | ( | state_t const & | x,
|  | state_t & | dxdt,
|  | double | mass ) const

virtual inherited

F function such as dx/dt=F(x,cst).

Reimplemented in Gyoto::Metric::KerrBL, Gyoto::Metric::Minkowski, Gyoto::Metric::NumericalMetricLorene, and Gyoto::Metric::RotStar3_1.

## diff31()

virtual int Gyoto::Metric::Generic::diff31 | ( | state_t const & | x,
|  | state_t & | dxdt,
|  | double | mass ) const

virtual inherited

F function such as dx/dt=F(x,cst) for 3+1 case.

Reimplemented in Gyoto::Metric::KerrBL, and Gyoto::Metric::NumericalMetricLorene.

## dualOneForm()

void Gyoto::Metric::Generic::dualOneForm | ( | double const | IN_ARRAY1_1[4],
|  | double const | IN_ARRAY1_2[4],
|  | double | ARGOUT_ARRAY1[4] ) const

inherited

Computes dual 1-form Compute the dual 1-form of 4-vector.

Parameters

  | IN_ARRAY1_1 | 4-position;
  | IN_ARRAY1_2 | quadrivector;
  [out] | ARGOUT_ARRAY1 | output 1-form

## fillElement()

virtual void Gyoto::Object::fillElement | ( | Gyoto::FactoryMessenger * | fmp | ) | const

virtual inherited

Fill the XML element for this Object.

The base implementation simply calls fillProperty() for each Property defined for the Object.

Derived classes should avoid overriding fillElement(). It may make sense occasionally, e.g. to make sure that the metric is output first.

To customize how a given Property is rendered, it is better to override fillProperty().

If this method is overridden, the implementation should in general call fillElement() on the direct base.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Metric::Complex, Gyoto::Scenery, and Gyoto::Spectrometer::Complex.

## fillProperty()

virtual void Gyoto::Object::fillProperty | ( | Gyoto::FactoryMessenger * | fmp,
|  | Property const & | p ) const

virtual inherited

Output a single Property to XML.

The base implementation decides what to do based on the p.type. The format matches how setParameters() an setParameter() would interpret the XML descition.

Overriding this method should be avoided, but makes sense in some cases (for instance Screen::fillProperty() selects a different unit for Distance based on its magnitude, so that stellar sizes are expressed in solar radii while smaller sizes can be expressed in meters and larger sizes in parsecs).

Overriding implementation should fall-back on calling the implementation in the direct parent class:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const ;
};
void B::fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const {
if (name=="Duff") fmp->doSomething();
else A::fillProperty(fmp, p);
}
Gyoto::FactoryMessenger
Factory / SmartPointee::Subcontractor_t interface.
Definition GyotoFactoryMessenger.h:92
Gyoto::Object::Object
Object(std::string const &kind)
Constructor setting kind.
Gyoto::Property
Property that can be set and got using standard methods.
Definition GyotoProperty.h:608

Reimplemented in Gyoto::Astrobj::DirectionalDisk, Gyoto::Astrobj::Disk3D, Gyoto::Astrobj::DynamicalDisk, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::NeutronStarModelAtmosphere, Gyoto::Astrobj::PatternDisk, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Star, Gyoto::Astrobj::XillverReflection, Gyoto::Metric::Shift, Gyoto::Scenery, Gyoto::Screen, and Gyoto::Spectrometer::Uniform.

## getPotential()

virtual double Gyoto::Metric::Hayward::getPotential | ( | double const | pos[4],
|  | double | l_cst ) const

virtual

Returns potential W=-ln(|u_t|) for a cst specific angular momentum l_cst Should be implemented in derived classes if useful If called on the base class, returns an error

Reimplemented from Gyoto::Metric::Generic.

## getProperties()

virtual Property const * Gyoto::Metric::Hayward::getProperties | ( |  | ) | const

virtual

Get list of properties.

This method is declared automatically by the GYOTO_OBJECT macro and defined automatically by the GYOTO_PROPERTY_END macro.

Reimplemented from Gyoto::Metric::Generic.

## getRmb()

virtual double Gyoto::Metric::Generic::getRmb | ( |  | ) | const

virtual inherited

Returns the marginally bound radius Should be implemented in derived classes if useful If called on the base class, returns an error

Reimplemented in Gyoto::Metric::KerrBL, Gyoto::Metric::NumericalMetricLorene, Gyoto::Metric::Python, and Gyoto::Metric::RezzollaZhidenko.

## getRms()

virtual double Gyoto::Metric::Generic::getRms | ( |  | ) | const

virtual inherited

Returns the marginally stable (ISCO) radius Should be implemented in derived classes if useful If called on the base class, returns an error

Reimplemented in Gyoto::Metric::KerrBL, Gyoto::Metric::NumericalMetricLorene, Gyoto::Metric::Python, and Gyoto::Metric::RezzollaZhidenko.

## getSpecificAngularMomentum()

virtual double Gyoto::Metric::Hayward::getSpecificAngularMomentum | ( | double | rr | ) | const

virtual

Returns the specific angular momentum l=-u_phi/u_t Should be implemented in derived classes if useful If called on the base class, returns an error

Reimplemented from Gyoto::Metric::Generic.

## gmunu() [1/2]

void Gyoto::Metric::Hayward::gmunu | ( | double | ARGOUT_ARRAY2[4][4],
|  | const double | IN_ARRAY1[4] ) const

virtual

Metric coefficients.

The default implementation calls double gmunu(const double * x, int mu, int nu) const.

Parameters

  [out] | ARGOUT_ARRAY2 | (g) 4x4 array to store the coeefficients
  [in] | IN_ARRAY1 | (x) 4-position at which to compute the coefficients;

Returns
  Metric coefficient gμ,ν at point x

Reimplemented from Gyoto::Metric::Generic.

## gmunu() [2/2]

double Gyoto::Metric::Hayward::gmunu | ( | double const | x[4],
|  | int | mu,
|  | int | nu ) const

virtual

Metric coefficients.

The default implementation calls Metric:: gmunu(double g[4][4], const double * pos) const

Parameters

  x | 4-position at which to compute the coefficient;
  mu | 1st index of coefficient, 0≤μ≤3;
  nu | 2nd index of coefficient, 0≤ν≤3;

Returns
  Metric coefficient gμ,ν at point x

Reimplemented from Gyoto::Metric::Generic.

## gmunu_up() [1/2]

void Gyoto::Metric::Hayward::gmunu_up | ( | double | ARGOUT_ARRAY2[4][4],
|  | const double | IN_ARRAY1[4] ) const

virtual

Metric contravariant coefficients.

The default implementation inverts the covariant coefficients matrix.

Reimplemented from Gyoto::Metric::Generic.

## gmunu_up() [2/2]

double Gyoto::Metric::Hayward::gmunu_up | ( | double const | x[4],
|  | int | mu,
|  | int | nu ) const

virtual

Metric contravariant coefficients.

The default implementation calls Metric:: gmunu_up(double g[4][4], const double * pos) const

Parameters

  x | 4-position at which to compute the coefficient;
  mu | 1st index of coefficient, 0≤μ≤3;
  nu | 2nd index of coefficient, 0≤ν≤3;

Returns
  Metric coefficient gμ,ν at point x

Reimplemented from Gyoto::Metric::Generic.

## gmunu_up_and_jacobian()

virtual void Gyoto::Metric::Generic::gmunu_up_and_jacobian | ( | double | ARGOUT_ARRAY2[4][4],
|  | double | ARGOUT_ARRAY3[4][4][4],
|  | const double | IN_ARRAY1[4] ) const

virtual inherited

gmunu_up() and jacobian() in one go

Reimplemented in Gyoto::Metric::KerrKS.

## GramSchmidt()

void Gyoto::Metric::Generic::GramSchmidt | ( | double const | pos[4],
|  | double | u0[4],
|  | double | u1[4],
|  | double | u2[4],
|  | double | u3[4] ) const

inherited

Apply Gram-Schmidt orthonormalization to a basis.

On input, u0 to u3 must be four non-zero norm, independent 4-vectors. On output, they will form an orthonormal basis.

Parameters

  [in] | pos | position,
  [in,out] | u0 | basis vector
  [in,out] | u1 | basis vector
  [in,out] | u2 | basis vector
  [in,out] | u3 | basis vector

## help()

void Gyoto::Object::help | ( |  | ) | const

inherited

Print (to stdout) some help on this class.

Describe all properties that this instance supports.

## hook()

virtual void Gyoto::Hook::Teller::hook | ( | Listener * | listener | ) |

virtual inherited

Start listening.

Use from a Hook::Listener object method:

teller->hook(this)

where "this" is a Listener and "teller" is a Teller.

Use unhook() later to stop listening to a given Teller.

Parameters

  listener | pointer to the new listener

## isStopCondition()

virtual int Gyoto::Metric::Generic::isStopCondition | ( | double const | coord[8] | ) | const

virtual inherited

Check whether integration should stop.

The integrating loop will ask this the Metric through this method whether or not it is happy to continue the integration. Typically, the Metric should answer 0 when everything is fine, 1 when too close to the event horizon, inside the BH...

Parameters

  coord | 8-coordinate vector to check.

Reimplemented in Gyoto::Metric::Complex, Gyoto::Metric::KerrBL, Gyoto::Metric::KerrKS, Gyoto::Metric::Python, Gyoto::Metric::RezzollaZhidenko, Gyoto::Metric::SchwarzschildHarmonic, and Gyoto::Metric::Shift.

## isThreadSafe()

virtual bool Gyoto::Object::isThreadSafe | ( |  | ) | const

virtual inherited

Whether this class is thread-safe.

Return True if this object is thread-safe, i.e. if an instance and its clone can be used in parallel threads (in the context of Scenery::raytrace()). Known objects which are not thread-safe include Lorene metrics and everything from the Python plug-in.

The default implementation considers that the class itself is thread safe and recurses into the declared properties to check whether they are safe too. Classes that abide to the Object/Property paradigm and are themselves thread-safe have nothing special to do.

Objects that clone children in their copy constructor that are not declared as properties must take these children into account.

Classes that are never thread-safe must declare it. It acn be easily done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and GYOTO_PROPERTY_THREAD_UNSAFE in the class definition.

## jacobian()

virtual void Gyoto::Metric::Generic::jacobian | ( | double | ARGOUT_ARRAY3[4][4][4],
|  | const double | IN_ARRAY1[4] ) const

virtual inherited

Derivatives of the metric covariant coefficients.

The default implementation evaluates them numerically. The gmunu matrix is assumed to be symmetrical but no other assumptions are made at the moment.

Reimplemented in Gyoto::Metric::Complex, Gyoto::Metric::KerrKS, Gyoto::Metric::NumericalMetricLorene, and Gyoto::Metric::Shift.

## kind() [1/2]

virtual std::string Gyoto::Object::kind | ( |  | ) | const

virtual inherited

Get kind_.

Reimplemented in Gyoto::Spectrometer::Uniform.

## kind() [2/2]

virtual void Gyoto::Object::kind | ( | const std::string |  | ) |

protected virtual inherited

Set kind_.

kind(const std::string) is protected because, for most Objects, it should not be changed in runtime. Set kind_

## mass() [1/2]

virtual void Gyoto::Metric::Generic::mass | ( | const double |  | ) |

virtual inherited

Set mass used in unitLength().

Reimplemented in Gyoto::Metric::Python, and Gyoto::Metric::Shift.

## mass() [2/2]

virtual void Gyoto::Metric::Generic::mass | ( | const double | ,
|  | const std::string & | unit )

virtual inherited

Set mass used in unitLength().

Reimplemented in Gyoto::Metric::Python.

## myrk4() [1/2]

virtual int Gyoto::Metric::Generic::myrk4 | ( | Worldline * | line,
|  | const double | coord[8],
|  | double | h,
|  | double | res[8] ) const

virtual delete inherited

Obsolete, update your code.

Reimplemented in Gyoto::Metric::RotStar3_1.

## myrk4() [2/2]

virtual int Gyoto::Metric::Generic::myrk4 | ( | Worldline * | line,
|  | state_t const & | coord,
|  | double | h,
|  | state_t & | res ) const

virtual inherited

RK4 integrator.

Reimplemented in Gyoto::Metric::KerrBL, and Gyoto::Metric::RotStar3_1.

## myrk4_adaptive()

virtual int Gyoto::Metric::Generic::myrk4_adaptive | ( | Gyoto::Worldline * | line,
|  | state_t const & | coord,
|  | double | lastnorm,
|  | double | normref,
|  | state_t & | coordnew,
|  | double | h0,
|  | double & | h1,
|  | double | deltamax = GYOTO_DEFAULT_DELTA_MAX ) const

virtual inherited

RK4 integrator with adaptive step.

Reimplemented in Gyoto::Metric::KerrBL, and Gyoto::Metric::RotStar3_1.

## norm()

double Gyoto::Metric::Generic::norm | ( | const double | pos[4],
|  | const double | u1[4] ) const

inherited

Scalar product.

Compute the norm of the quadrivector u1 in this Metric, at point pos expressed in coordinate system sys.

Parameters

  [in] | pos | 4-position;
  [in] | u1 | quadrivector;

Returns
  ||u1||

## normalizeFourVel() [1/2]

virtual void Gyoto::Metric::Generic::normalizeFourVel | ( | double const | pos[4],
|  | double | fourvel[4] ) const

virtual inherited

Normalize fourvelvel to -1.

First computes threevel as xiprime=xidot/x0dot for i in {1, 2, 3}, then computes x0dot using SyPrimeToTdot, then computes again xidot as xidot=xiprime*x0dot.

Parameters

  [in] | pos | 4-position;
  [in,out] | fourvel | 4-velocity, will be renormalized.

## normalizeFourVel() [2/2]

virtual void Gyoto::Metric::Generic::normalizeFourVel | ( | double | coord[8] | ) | const

virtual inherited

Normalize fourvelvel to -1.

First computes threevel as xiprime=xidot/x0dot for i in {1, 2, 3}, then computes x0dot using SyPrimeToTdot, then computes again xidot as xidot=xiprime*x0dot.

Parameters

  [in,out] | coord | 8-position, coord[4-7] will be set according to the other elements;

## nullifyCoord() [1/2]

virtual void Gyoto::Metric::Generic::nullifyCoord | ( | double | coord[8] | ) | const

virtual inherited

Set tdot (coord[4]) such that coord is light-like. Everything is in geometrical units.

Set coord[4] so that the 4-velocity coord[4:7] is lightlike, i.e. of norm 0. There may be up to two solutions. coord[4] is set to the hightest. The lowest can be retrieved using nullifyCoord(double coord[8], double& tdot2) const. Everything is expressed in geometrical units.

Parameters

  [in,out] | coord | 8-position, coord[4] will be set according to the other elements;

Reimplemented in Gyoto::Metric::KerrBL.

## nullifyCoord() [2/2]

virtual void Gyoto::Metric::Generic::nullifyCoord | ( | double | coord[8],
|  | double & | tdot2 ) const

virtual inherited

Set tdot (coord[4]) such that coord is light-like and return other possible tdot.

Set coord[4] so that the 4-velocity coord[4:7] is lightlike, i.e. of norm 0. There may be up to two solutions. coord[4] is set to the hightest. The lowest can be retrieved in tdot2. Everything is expressed in geometrical units.

Parameters

  [in,out] | coord | 8-position, coord[4] will be set according to the other elements;
  [out] | tdot2 | will be set to the smallest solution

Reimplemented in Gyoto::Metric::KerrBL.

## observerTetrad() [1/2]

virtual void Gyoto::Metric::Generic::observerTetrad | ( | double const | pos[4],
|  | double | fourvel[4],
|  | double | screen1[4],
|  | double | screen2[4],
|  | double | screen3[4] ) const

virtual inherited

Computes the orthonormal local tetrad of the observer.

Parameters

  [in] | pos | position,
  [in] | fourvel | observer 4-velocity (norm -1)
  [out] | screen1 | first vector in the screen plane
  [out] | screen2 | second vector in the screen plane
  [out] | screen3 | vector normal to the screen

Reimplemented in Gyoto::Metric::KerrBL.

## observerTetrad() [2/2]

virtual void Gyoto::Metric::Generic::observerTetrad | ( | obskind_t | obskind,
|  | double const | pos[4],
|  | double | fourvel[4],
|  | double | screen1[4],
|  | double | screen2[4],
|  | double | screen3[4] ) const

virtual inherited

Computes the orthonormal local tetrad of the observer.

Parameters

  obskind | input: kind of observer (eg: "ZAMO","KeplerianObserver"...)
  pos | input: position,
  fourvel | output: observer 4-velocity (norm -1)
  screen1 | output: first vector in the screen plane
  screen2 | output: second vector in the screen plane
  screen3 | output: vector normal to the screen

Reimplemented in Gyoto::Metric::Minkowski.

## property()

Property const * Gyoto::Object::property | ( | std::string const | pname | ) | const

inherited

Find property by name.

Look into the Property list for a Property whose name (or name_false, for a boolean Property) is pname. Return a const pointer to the first such property found, or NULL if none is found.

## ScalarProd()

double Gyoto::Metric::Hayward::ScalarProd | ( | const double | pos[4],
|  | const double | u1[4],
|  | const double | u2[4] ) const

virtual

Scalar product.

Compute the scalarproduct of the two quadrivectors u1 and u2 in this Metric, at point pos expressed in coordinate system sys.

Parameters

  pos | 4-position;
  u1 | 1st quadrivector;
  u2 | 2nd quadrivector;

Returns
  u1*u2

Reimplemented from Gyoto::Metric::Generic.

## setParameter() [1/2]

virtual void Gyoto::Object::setParameter | ( | Gyoto::Property const & | p,
|  | std::string const & | name,
|  | std::string const & | content,
|  | std::string const & | unit )

virtual inherited

Set parameter by Property (and name).

This function is used when parsing an XML description, if Property (p) of this name is found (i.e. either p.name or p.name_false is equal to name). Implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit);
};
void B::setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else A::setParameter(p, name, content, unit);
}

Parameters

  p | Property that matches name (p.name == name or p.name_false == name)
  name | XML name of the parameter (XML entity)
  content | string representation of the value
  unit | string representation of the unit

Reimplemented in Gyoto::Astrobj::PolishDoughnut.

## setParameter() [2/2]

virtual int Gyoto::Object::setParameter | ( | std::string | name,
|  | std::string | content,
|  | std::string | unit )

virtual inherited

Set parameter by name.

This function is used when parsing an XML description, if no Property of this name is found. Overriding implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual int setParameter(std::string name,
std::string content,
std::string unit);
};
int B::setParameter(std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else return A::setParameter(name, content, unit);
return 0; // name was known
}

Parameters

  name | XML name of the parameter (XML entity). This may have a path component, e.g. "Astrobj::Radius", in which case a property named "Astrobj" will be sought in the current object, and setParameter will be called recusrively on this Astrobj with Radius as name.
  content | string representation of the value
  unit | string representation of the unit

Returns
  0 if this parameter is known, 1 if it is not.

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::Star, Gyoto::Metric::KerrKS, and Gyoto::Metric::RotStar3_1.

## setParameters()

virtual void Gyoto::Object::setParameters | ( | Gyoto::FactoryMessenger * | fmp | ) |

virtual inherited

Main loop for parsing Properties from XML description.

    This function queries the FactoryMessenger for elements to parse,
    and tries to matche each element to a Property to set it
    accordingly.

    Any class that tries to be buildable from XML must supply a
    subcontractor (for base classes such as Metric, Astrobj, Spectrum
    and Spectrometer, it is done as a template that must be
    specialized for each class).

    This subcontractor typically looks somewhat like this:

SmartPointer<Metric::Generic>
Gyoto::Metric::MyKind::Subcontractor(FactoryMessenger* fmp) {
SmartPointer<MyKind> gg = new MyKind();
gg -> setParameters(fmp);
return gg;
}
Gyoto::Object::setParameters
virtual void setParameters(Gyoto::FactoryMessenger *fmp)
Main loop for parsing Properties from XML description.
Gyoto::SmartPointer
Pointers performing reference counting.
Definition GyotoSmartPointer.h:135

    Although this is discouraged, it is possible to override the
    following functions to customize how XML entities are parsed:
      - setParameters() if low-level access to the
        FactoryMessenger is required;
      - setParameter(std::string name,
                     std::string content,
                     std::string unit)
        to interpret an entity that does not match a Property
        (e.g. alternative name);
      - setParameter(Gyoto::Property const &p,
                     std::string const &name,
                     std::string const &content,
                     std::string const &unit)
        to change how a Property is interpreted.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::Generic, Gyoto::Astrobj::OscilTorus, Gyoto::Astrobj::Star, Gyoto::Metric::Complex, Gyoto::Metric::Shift, Gyoto::Photon, Gyoto::Spectrometer::Complex, and Gyoto::Spectrometer::Uniform.

## SysPrimeToTdot()

virtual double Gyoto::Metric::Generic::SysPrimeToTdot | ( | const double | coord[4],
|  | const double | v[3] ) const

virtual inherited

Compute tdot as a function of dr/dt, dtheta/dt and dphi/dt. Everything is in geometrical units.

Parameters

  coord | 4-position (geometrical units);
  v | 3-velocity dx1/dx0, dx2/dx0, dx3/dx0;

Returns
  tdot = dx0/dtau.

## tellListeners()

virtual void Gyoto::Hook::Teller::tellListeners | ( |  | ) |

protected virtual inherited

Call tell() on each hooked Listener.

Whenever a Teller mutates, it should warn any Listener hooked to it using tellListeners().

## unhook()

virtual void Gyoto::Hook::Teller::unhook | ( | Listener * | listener | ) |

virtual inherited

Stop listening.

Use from a Hook::Listener object method:

teller->unhook(this)

where "this" is a Listener, "teller" is a Teller, and "this" has called teller->hook(this) previously.

Parameters

  listener | pointer to the listener

## unitLength()

double Gyoto::Metric::Generic::unitLength | ( |  | ) | const

inherited

M * G / c^2, M is in kg, unitLength in meters.

Metrics implementations are free to express lengths and distances in whatever unit they see fit (presumably most often geometrical units). This function returns this unit in SI (meters).

## zamoVelocity()

virtual void Gyoto::Metric::Generic::zamoVelocity | ( | double const | pos[4],
|  | double | vel[4] ) const

virtual inherited

Yield ZAMO velocity at a given position.

Give the velocity of a zero angular momentul observer (whatever is closest to "at rest"). The default implementation simply projects (1, 0, 0, 0) othogonally along ephi and normalizes it, thus ensuring that vel is orthogonal to ephi.

Parameters

  pos | input: position,
  vel | output: velocity,

Reimplemented in Gyoto::Metric::KerrBL.

## Member Data Documentation

## __defaultfeatures

int Gyoto::Metric::Generic::__defaultfeatures

private inherited

Whether some virtual methods are implemented.

The default implementations of some methods call one-another. This member is used internally to avoid infinite recursion.

## delta_max_over_r_

double Gyoto::Metric::Generic::delta_max_over_r_

protected inherited

Numerical tuning parameter.

Ensure that delta (the numerical integration step) is never larger than a fraction of the distance between the current location and the center of the coordinate system.

For investigations close to the event horizon, 0.5 is usually fine. If high accuracy is needed long after deflection (weak lensing), then this must be smaller. A good test is to look at a MinDistance map for a FixedStar: it must be smooth.

## kind_

std::string Gyoto::Object::kind_

protected inherited

The "kind" that is output in the XML entity.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj kind="kind_" ...>...</Astrobj>
Gyoto::Object::kind
virtual void kind(const std::string)
Set kind_.
Gyoto::Astrobj
Access to astronomical objects.
Definition GyotoAstrobj.h:49

is written.

## mutex_

pthread_mutex_t Gyoto::SmartPointee::mutex_

private inherited

A mutex.

When compiled with libpthread

## plugins_

std::vector<std::string> Gyoto::Object::plugins_

protected inherited

The plug-ins that needs to be loaded to access this instance's class.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj ... plugin="plugins_">...</Astrobj>

is written.

The documentation for this class was generated from the following file:

- GyotoHayward.h